"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var s_core_1 = require("@serverless-devs/s-core");
var static_1 = require("./static");
var fse = require('fs-extra');
var path = require('path');
var REGION = static_1.DEFAULT.REGION, SERVICE = static_1.DEFAULT.SERVICE, FUNCTION = static_1.DEFAULT.FUNCTION, TRIGGERS = static_1.DEFAULT.TRIGGERS, DOMAINS = static_1.DEFAULT.DOMAINS, SRARTCONFIG = static_1.DEFAULT.SRARTCONFIG;
var Framework = /** @class */ (function (_super) {
    __extends(Framework, _super);
    function Framework(id) {
        return _super.call(this, id) || this;
    }
    Framework.prototype.deploy = function (inputs) {
        return __awaiter(this, void 0, void 0, function () {
            var fc, Project, Credentials, Properties, _a, Region, CodeUri, Domains, Environment, Log, _b, Detail, Service, Function, StartConfig, cacheFunction, state;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.load('fc', 'Component')];
                    case 1:
                        fc = _c.sent();
                        Project = inputs.Project, Credentials = inputs.Credentials, Properties = inputs.Properties;
                        _a = Properties.Region, Region = _a === void 0 ? REGION : _a, CodeUri = Properties.CodeUri, Domains = Properties.Domains, Environment = Properties.Environment, Log = Properties.Log, _b = Properties.Detail, Detail = _b === void 0 ? {} : _b;
                        if (!CodeUri) {
                            throw new Error('CodeUri does not exist.');
                        }
                        Service = Detail.Service, Function = Detail.Function, StartConfig = Detail.StartConfig;
                        Service = Object.assign(SERVICE, fc.state.Service || {}, Service || {});
                        if (Log) {
                            Service.Log = Log;
                        }
                        cacheFunction = fc.state.Function || {};
                        Function = Object.assign(FUNCTION, cacheFunction, Function);
                        if (Environment) {
                            Function.Environment = Environment;
                        }
                        if (!Function.Triggers) {
                            Function.Triggers = TRIGGERS;
                        }
                        Function.Triggers = this.getTriggers(Domains, Function.Triggers);
                        Function.CodeUri = CodeUri;
                        Function.Runtime = 'custom';
                        return [4 /*yield*/, this.handlerStartConfig(CodeUri, StartConfig)];
                    case 2:
                        _c.sent();
                        return [4 /*yield*/, fc.deploy({
                                Args: { type: 'all' },
                                State: fc.state,
                                Credentials: Credentials,
                                Project: Project,
                                Properties: {
                                    Region: Region,
                                    Function: Function,
                                    Service: Service
                                }
                            })];
                    case 3:
                        state = _c.sent();
                        fc.state = { Function: Function, Service: Service };
                        return [4 /*yield*/, fc.save()];
                    case 4:
                        _c.sent();
                        return [2 /*return*/, state];
                }
            });
        });
    };
    Framework.prototype.handlerStartConfig = function (codeUri, startConfig) {
        return __awaiter(this, void 0, void 0, function () {
            var endPath, hasBootstrapFile, _a, Port, Start;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (codeUri.endsWith('.zip') || codeUri.endsWith('.jar') || codeUri.endsWith('.war')) {
                            return [2 /*return*/];
                        }
                        endPath = path.resolve(codeUri + "/bootstrap");
                        return [4 /*yield*/, fse.pathExists(endPath)];
                    case 1:
                        hasBootstrapFile = _b.sent();
                        if (hasBootstrapFile) {
                            if (!startConfig || startConfig.isReadCache) {
                                return [2 /*return*/];
                            }
                        }
                        _a = startConfig || SRARTCONFIG, Port = _a.Port, Start = _a.Start;
                        return [4 /*yield*/, fse.writeFile(endPath, "#!/usr/bin/env bash\n\nexport PORT=" + Port + "\n" + Start, {
                                mode: '0755'
                            })];
                    case 2:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Framework.prototype.getTriggers = function (domains, triggers) {
        var notDomain = !domains;
        return triggers.map(function (trigger) {
            var e_1, _a, e_2, _b;
            // 如果没有自定义域名 并且 trigger 有域名配置
            if (notDomain && trigger.Parameters.Domains && trigger.Parameters.Domains[0]) {
                return trigger;
            }
            trigger.Parameters.Domains = [];
            if (notDomain) {
                domains = DOMAINS;
            }
            try {
                for (var domains_1 = __values(domains), domains_1_1 = domains_1.next(); !domains_1_1.done; domains_1_1 = domains_1.next()) {
                    var domain = domains_1_1.value;
                    var qualifier = trigger.Parameters.Qualifier || 'LATEST';
                    var routes = domain.Routes || [];
                    try {
                        for (var routes_1 = (e_2 = void 0, __values(routes)), routes_1_1 = routes_1.next(); !routes_1_1.done; routes_1_1 = routes_1.next()) {
                            var route = routes_1_1.value;
                            var q = route.Qualifier || 'LATEST';
                            if (qualifier === q) {
                                trigger.Parameters.Domains.push(domain);
                                return trigger;
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (routes_1_1 && !routes_1_1.done && (_b = routes_1.return)) _b.call(routes_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (domains_1_1 && !domains_1_1.done && (_a = domains_1.return)) _a.call(domains_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return trigger;
        });
    };
    return Framework;
}(s_core_1.Component));
module.exports = Framework;
//# sourceMappingURL=index.js.map